import sys, os 


class descriptorPlots:
	def __init__(self, plotdir, datadict, segframes, fr):
		import matplotlib as plt
		
		
		for key in datadict.keys():
			if key.find('-seg') != -1: continue
			savepath = os.path.join(plotdir, key+'.jpg')
			width = len(datadict[key])/10.
			self.ploty(savepath, [datadict[key], datadict['power']], [key, 'power'], 10, width, segs=segframes)



	def ploty(self, name, data, labeled, height, width, segs=False):
		import matplotlib.pyplot as plt
		fig = plt.figure(figsize=(width, height))
		for item in data:
			plt.plot(range(len(item)), item, ls='steps-post', lw=1, label=labeled)
		if labeled != None:
			leg = plt.legend(labeled,'upper right', shadow=False)
			frame  = leg.get_frame()  
			frame.set_facecolor('0.90')    # set the frame face color to light gray
		if segs != False:
			for seg in segs: # plot segmentation
				plt.axvspan(seg[0], seg[1], facecolor='r', alpha=1, ec='r', lw=1)
		txtLoc = [0.01, 0.98]
		plt.savefig(name)
		plt.close()



#def waterfallPlot(name, TwoDArrays):
#	import numpy
#	from enthought.mayavi.mlab import figure, surf, savefig
#	fig = figure(fgcolor=(0,0,0), bgcolor=(1,1,1))
#	for TwoDArray in TwoDArrays:
#		surf(TwoDArray, colormap='Greys') #
#	savefig(name)

