sr = 44100
ksmps = 128
nchnls  =  2

giNoteCounter init 1
0dbfs = 1



; for phase vocoder time stretching, if indicated in iStretchCode (p17)
opcode	pvsbuffer_module, a, akkkiiii
	ain, kspeed, kbuflen, kscale, iFFTsize, ioverlap, iwinsize, iwintype	xin
	kPhOffset	=	0
	ktrig		changed		kbuflen
	ibuflen	init	1
	kspeed	init	1
	kscale	init	1
	if ktrig==1 then
	 reinit	UPDATE
	endif
	UPDATE:
	ibuflen		=	i(kbuflen)
	; WAVE SHAPE FOR A MOVING PHASE POINTER
	iphasor		ftgen		0, 0, 65536, 7, 0, 65536, 1
	; CREATE MOVING POINTER TO READ FROM BUFFER
	aread 		osciliktp 	kspeed/ibuflen, iphasor, kPhOffset
	kread		downsamp	  aread
	; RESCALE READ POINTER WITH PHASOR RANGE SLIDER
	kread		=		kread * ibuflen
	aFB		init		0
	; ANALYSE THE AUDIO SIGNAL THAT WAS CREATED IN INSTRUMENT 1. OUTPUT AN F-SIGNAL.
	f_anal 		pvsanal		ain+aFB, iFFTsize, ioverlap, iwinsize, iwintype
	; BUFFER FSIG
	ibuffer,ktime  	pvsbuffer   	f_anal, ibuflen
	rireturn
	; INITIALISE HANDLE TO BUFFER
	khandle		init 		ibuffer
	; READ BUFFER
	f_buf  		pvsbufread  	kread , khandle
	; RESCALE FREQUENCIES
	f_scale		pvscale 	f_buf, kscale
	; RESYNTHESIZE THE f-SIGNAL AS AN AUDIO SIGNAL	
	aresyn 		pvsynth  	f_scale
	xout		   aresyn	
endop




instr 2 ; target sf
	iTgtDur = p3
;	STgtFile   strget   p4
;	iStartRead = p5
;	iFileChannels   filenchnls   STgtFile
;	if (iFileChannels == 2) then ; STEREO
;		asnd1, asnd2  diskin2 STgtFile, 1, iStartRead
;	elseif (iFileChannels == 1) then ; MONO
;		asnd1         diskin2 STgtFile, 1, iStartRead
;		asnd2 = asnd1
;	endif 
;	ifftsize = 2048
;	ioverlap = ifftsize / 2.0
;	ftgt_l pvsanal  asnd1, ifftsize, ioverlap, ifftsize, 1
;	ftgt_r pvsanal  asnd2, ifftsize, ioverlap, ifftsize, 1
;	fcps_l pvsanal  ga_left, ifftsize, ioverlap, ifftsize, 1
;	fcps_r pvsanal  ga_right, ifftsize, ioverlap, ifftsize, 1
;	;fout_l pvsfilter fcps_l, ftgt_l, 1
;	;fout_r pvsfilter fcps_r, ftgt_r, 1
;	fout_l pvsmorph fcps_l, ftgt_l, 0.5, 1
;	fout_r pvsmorph fcps_r, ftgt_r, 0.5, 1
;	aout1  pvsynth   fout_l
;	aout2  pvsynth   fout_r
;;	outs asnd1, asnd2
;
;	outs 	aout1, aout2
;	clear ga_left, ga_right
endin


instr 1
	iCpsSegDur = p3
	iCpsAmpDb = p4
	SCpsFile   strget   p5
	iStartRead = p6
	iTransposition = p7
	iRmsAmp = p8
	iPeakTime = p9
	iEffDur = p10
	iAttackTime = p11
	iDecayTime = p12
	iEnvSlope = p13
	iCorpusID = p14
	iSimSelectNumb = p15
	iTgtSegDur = p16
	iTgtSegNumb = p17
	iStretchCode = p18
	
	iFileChannels   filenchnls   SCpsFile
	
	print giNoteCounter ; used by audioguide for its printed progress bar
	
	if (iStretchCode == 0) then ; NORMAL PLAYBACK
		if (iFileChannels == 2) then ; STEREO
			asnd1, asnd2  diskin2 SCpsFile, iTransposition, iStartRead
		elseif (iFileChannels == 1) then ; MONO
			asnd1         diskin2 SCpsFile, iTransposition, iStartRead
			asnd2 = asnd1
		endif 

	elseif (iStretchCode == 1) then ; DO PHASE VOCODER TIME STRETCHING
		prints "PHASE VOCODER TIME STRETCHING\n"
		if (iFileChannels == 2) then ; STEREO
			asnd1, asnd2  diskin2 SCpsFile, iTransposition, iStartRead
		elseif (iFileChannels == 1) then ; MONO
			asnd1         diskin2 SCpsFile, iTransposition, iStartRead
			asnd2 = asnd1
		endif 
		istretch = iCpsSegDur/iTgtSegDur
		kspeed = istretch
		iCpsSegDur = iCpsSegDur * (1/istretch)
		iDecayTime = iDecayTime * (1/istretch)
		p3 = iTgtSegDur
		kbuflen = 100
		asnd1    pvsbuffer_module   asnd1, kspeed, kbuflen, iTransposition, 1024, 256, 1024, 1
		asnd2    pvsbuffer_module   asnd2, kspeed, kbuflen, iTransposition, 1024, 256, 1024, 1

	elseif (iStretchCode == 2) then ; TAPE HEAD TIME STRETCHING (transposition change)
		istretch = iCpsSegDur/iTgtSegDur
		iCpsSegDur = iCpsSegDur * (1/istretch)
		iDecayTime = iDecayTime * (1/istretch)
		iTransposition = istretch ; overwrite any onther transposition !
		p3 = iTgtSegDur

		prints "TAPE-HEAD TRANSPOSITION TIME STRETCHING\n"
		if (iFileChannels == 2) then ; STEREO
			asnd1, asnd2  diskin2 SCpsFile, iTransposition, iStartRead
		elseif (iFileChannels == 1) then ; MONO
			asnd1         diskin2 SCpsFile, iTransposition, iStartRead
			asnd2 = asnd1
		endif 
	endif

	; do envelope
	aAmp    linseg   0, iAttackTime, 1, iCpsSegDur-iDecayTime-iAttackTime, 1, iDecayTime, 0
	aAmp   pow    aAmp, iEnvSlope
	aAmp = aAmp * ampdbfs(iCpsAmpDb-100)
	; write to file
	outs asnd1*aAmp, asnd2*aAmp
	
	giNoteCounter = giNoteCounter+1 ; increment
endin


