# this will make the output file 'output/bachCommands.txt' and 
# this file can be viewed in MAX/msp with the patch examples/musicalWriting.maxpat 


# specify the timbral descriptors used for similarity calculation
#	note that "temporal descriptors" are included in the parameter package
TARGET = tsf('cage.aiff', thresh=-28)

# you can also use directory names to specify corpus entries.
# each soundfile in the directory will be used, as long as its extension is in the list SOUNDFILE_EXTENSIONS
CORPUS = [
csf('lachenmann.aiff', MWinstrName='pianoPart'),
]


SEARCH = [
spass('closest', d('mfccs'), d('centroid-delta', norm=1))
]
SUPERIMPOSE = si(maxOnset=2, maxOverlap=4)


BACH_SCORE_FILEPATH = 'output/bachCommands.txt'



# MW_DEFINE_INSTRUMENTS is where you define what staves will corrispod to which corpus entries.
# the order of instruments is the order they will appear in the bach score
# instruments are associated with corpus entries with the corpus parameter 'MWinstr', it must match item 1 of the tuple.  item 2 of the tuple is a dict with data about the clef/key/midi channnel.
# instruments are not included in the output score unless samples are actually chosen during cocatenation
MW_DEFINE_INSTRUMENTS = [('pianoPart', {'clef': 'FG'})] # you can also specify {'key': 'CM', 'midiChn': 1}




